﻿namespace UltraCalendarAppointmentPicture
{
    using System;
    using System.Drawing;

    using Infragistics.Win;
    using Infragistics.Win.UltraWinSchedule;
    using Infragistics.Win.UltraWinSchedule.MonthViewSingle;

   public class MyCreationFilter : IUIElementCreationFilter
    {
        private Bitmap imageSized = new Bitmap(SystemIcons.Asterisk.ToBitmap(), new Size(12, 12));
        
        public void AfterCreateChildElements(UIElement parent)
        {
            Appointment appt = null;
            Size margin = new Size();
            UIElement prevSibling = null;
            if (parent is Infragistics.Win.UltraWinSchedule.DayView.AppointmentUIElement)
            {
                Infragistics.Win.UltraWinSchedule.DayView.AppointmentUIElement elem = parent as Infragistics.Win.UltraWinSchedule.DayView.AppointmentUIElement;
                appt = elem.SelectableItem as Appointment;
                margin = new Size(8, 4);
                prevSibling = parent.GetDescendant(typeof(EditorWithTextUIElement));
            }
            else if (parent is Infragistics.Win.UltraWinSchedule.MonthViewSingle.AppointmentUIElement)
            {
                Infragistics.Win.UltraWinSchedule.MonthViewSingle.AppointmentUIElement elem = parent as Infragistics.Win.UltraWinSchedule.MonthViewSingle.AppointmentUIElement;
                appt = elem.SelectableItem as Appointment;
                margin = new Size(8, 2);
                prevSibling = parent.GetDescendant(typeof(SingleDayAppointmentSubjectUIElement));
            }
            else if (parent is Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement)
            {
                Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement elem = parent as Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement;
                appt = elem.SelectableItem as Appointment;
                margin = new Size(8, 2);
                prevSibling = parent.GetDescendant(typeof(EditorWithTextUIElement));
            }
 
            this.AddIconIfRequired(parent, appt, margin, prevSibling);
        }
 
        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
 
        private void AddIconIfRequired(UIElement parent, Appointment appt, Size margin, UIElement prevSibling)
        {
            if (appt != null)
            {
                ImageUIElement recurrenceIcon = new ImageUIElement(parent, this.imageSized);

                    Point ptIcon = new Point(Math.Max(parent.Rect.Right - this.imageSized.Size.Width - margin.Width, 0), parent.Rect.Top + margin.Height);
 
                    // resize the previous sibling element to accommodate the new icon
                    if (prevSibling != null)
                    {
                        prevSibling.Rect = new Rectangle(prevSibling.Rect.Location, new Size(Math.Max(prevSibling.Rect.Width - this.imageSized.Size.Width - margin.Width, 0), prevSibling.Rect.Height));
                    }

                    if (prevSibling.Rect.Width - margin.Width > this.imageSized.Width)
                    {
                        recurrenceIcon.Rect = new System.Drawing.Rectangle(ptIcon, new Size(this.imageSized.Size.Width, this.imageSized.Size.Height));
                        parent.ChildElements.Add(recurrenceIcon);    
                    }
            }
        }
    }
}